/** @file simpleview_cmd.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.21
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef SIMPLEVIEW_CMD_H
#define SIMPLEVIEW_CMD_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define CMDLINE_PARSER_PACKAGE "simpleview"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "0.23"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int verbosity_arg;	/**< @brief Set the verbosity level (0=quiet 10=verbose 20=bombastic) (default='0').  */
  char * verbosity_orig;	/**< @brief Set the verbosity level (0=quiet 10=verbose 20=bombastic) original value given at command line.  */
  const char *verbosity_help; /**< @brief Set the verbosity level (0=quiet 10=verbose 20=bombastic) help description.  */
  int width_arg;	/**< @brief Width of rendered frames in pixels (default='1024').  */
  char * width_orig;	/**< @brief Width of rendered frames in pixels original value given at command line.  */
  const char *width_help; /**< @brief Width of rendered frames in pixels help description.  */
  int height_arg;	/**< @brief Height of rendered frames in pixels (default='768').  */
  char * height_orig;	/**< @brief Height of rendered frames in pixels original value given at command line.  */
  const char *height_help; /**< @brief Height of rendered frames in pixels help description.  */
  char * color_arg;	/**< @brief Set the background color, e.g. white would be 255,255,255 (default='0,0,0').  */
  char * color_orig;	/**< @brief Set the background color, e.g. white would be 255,255,255 original value given at command line.  */
  const char *color_help; /**< @brief Set the background color, e.g. white would be 255,255,255 help description.  */
  char * basename_arg;	/**< @brief Basename to use when creating output files (default='simpleview-frame-').  */
  char * basename_orig;	/**< @brief Basename to use when creating output files original value given at command line.  */
  const char *basename_help; /**< @brief Basename to use when creating output files help description.  */
  const char *keys_help; /**< @brief Dump the hot keys list that work inside the viewer help description.  */
  const char *list_help; /**< @brief List the output file formats available for dumping images help description.  */
  char * type_arg;	/**< @brief File format to write rendered files too.  See --list for file types (default='rgb').  */
  char * type_orig;	/**< @brief File format to write rendered files too.  See --list for file types original value given at command line.  */
  const char *type_help; /**< @brief File format to write rendered files too.  See --list for file types help description.  */
  char * waypoints_arg;	/**< @brief Load in waypoints from a file.  */
  char * waypoints_orig;	/**< @brief Load in waypoints from a file original value given at command line.  */
  const char *waypoints_help; /**< @brief Load in waypoints from a file help description.  */
  float interval_arg;	/**< @brief Minimum time between each frame in animating (default='0.25').  */
  char * interval_orig;	/**< @brief Minimum time between each frame in animating original value given at command line.  */
  const char *interval_help; /**< @brief Minimum time between each frame in animating help description.  */
  float percent_arg;	/**< @brief Fraction to move between each waypoint after each frame [0..1].  It is recommended to use an even divisor of 1.0 or your animation will jump at each waypoint (default='0.1').  */
  char * percent_orig;	/**< @brief Fraction to move between each waypoint after each frame [0..1].  It is recommended to use an even divisor of 1.0 or your animation will jump at each waypoint original value given at command line.  */
  const char *percent_help; /**< @brief Fraction to move between each waypoint after each frame [0..1].  It is recommended to use an even divisor of 1.0 or your animation will jump at each waypoint help description.  */
  int noloop_flag;	/**< @brief loop the animation (default=off).  */
  const char *noloop_help; /**< @brief loop the animation help description.  */
  char * statestamp_arg;	/**< @brief State history xml file to use for animation (SSML).  */
  char * statestamp_orig;	/**< @brief State history xml file to use for animation (SSML) original value given at command line.  */
  const char *statestamp_help; /**< @brief State history xml file to use for animation (SSML) help description.  */
  float timescale_arg;	/**< @brief Scale the rate that time goes by for SSML (8..10 for Phoenix; 1 for realtime) (default='1').  */
  char * timescale_orig;	/**< @brief Scale the rate that time goes by for SSML (8..10 for Phoenix; 1 for realtime) original value given at command line.  */
  const char *timescale_help; /**< @brief Scale the rate that time goes by for SSML (8..10 for Phoenix; 1 for realtime) help description.  */
  
  int help_given ;	/**< @brief Whether help was given.  */
  int version_given ;	/**< @brief Whether version was given.  */
  int verbosity_given ;	/**< @brief Whether verbosity was given.  */
  int width_given ;	/**< @brief Whether width was given.  */
  int height_given ;	/**< @brief Whether height was given.  */
  int color_given ;	/**< @brief Whether color was given.  */
  int basename_given ;	/**< @brief Whether basename was given.  */
  int keys_given ;	/**< @brief Whether keys was given.  */
  int list_given ;	/**< @brief Whether list was given.  */
  int type_given ;	/**< @brief Whether type was given.  */
  int waypoints_given ;	/**< @brief Whether waypoints was given.  */
  int interval_given ;	/**< @brief Whether interval was given.  */
  int percent_given ;	/**< @brief Whether percent was given.  */
  int noloop_given ;	/**< @brief Whether noloop was given.  */
  int statestamp_given ;	/**< @brief Whether statestamp was given.  */
  int timescale_given ;	/**< @brief Whether timescale was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 0) */
  int check_required; /**< @brief whether to check that all required options were provided (default 0) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to 0
 * @return the initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_init();

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* SIMPLEVIEW_CMD_H */
