/** @file spin_gnuplot_cmd.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.21
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef SPIN_GNUPLOT_CMD_H
#define SPIN_GNUPLOT_CMD_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define CMDLINE_PARSER_PACKAGE "spin_gnuplot"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "0.24"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int verbosity_arg;	/**< @brief Set the verbosity level (0=quiet 10=verbose 20=bombastic) (default='0').  */
  char * verbosity_orig;	/**< @brief Set the verbosity level (0=quiet 10=verbose 20=bombastic) original value given at command line.  */
  const char *verbosity_help; /**< @brief Set the verbosity level (0=quiet 10=verbose 20=bombastic) help description.  */
  char * out_arg;	/**< @brief Write the binned counts to this file.  */
  char * out_orig;	/**< @brief Write the binned counts to this file original value given at command line.  */
  const char *out_help; /**< @brief Write the binned counts to this file help description.  */
  char * basename_arg;	/**< @brief prefix for frames written out to disk.  */
  char * basename_orig;	/**< @brief prefix for frames written out to disk original value given at command line.  */
  const char *basename_help; /**< @brief prefix for frames written out to disk help description.  */
  char * preamble_arg;	/**< @brief File of gnu plot commands to place in front of the plotting (title, range, etc).  */
  char * preamble_orig;	/**< @brief File of gnu plot commands to place in front of the plotting (title, range, etc) original value given at command line.  */
  const char *preamble_help; /**< @brief File of gnu plot commands to place in front of the plotting (title, range, etc) help description.  */
  char * FileInput_arg;	/**< @brief plot command is from a file.  */
  char * FileInput_orig;	/**< @brief plot command is from a file original value given at command line.  */
  const char *FileInput_help; /**< @brief plot command is from a file help description.  */
  char * StringInput_arg;	/**< @brief String to pass to splot or plot.  */
  char * StringInput_orig;	/**< @brief String to pass to splot or plot original value given at command line.  */
  const char *StringInput_help; /**< @brief String to pass to splot or plot help description.  */
  char * format_arg;	/**< @brief Output format (pdf,png,jpg,gif) for gnuplot output terminal (default='png').  */
  char * format_orig;	/**< @brief Output format (pdf,png,jpg,gif) for gnuplot output terminal original value given at command line.  */
  const char *format_help; /**< @brief Output format (pdf,png,jpg,gif) for gnuplot output terminal help description.  */
  float StepSize_arg;	/**< @brief How much to move between each frame (default='0.5').  */
  char * StepSize_orig;	/**< @brief How much to move between each frame original value given at command line.  */
  const char *StepSize_help; /**< @brief How much to move between each frame help description.  */
  float xmin_arg;	/**< @brief Starting rotation in degrees (default='45.0').  */
  char * xmin_orig;	/**< @brief Starting rotation in degrees original value given at command line.  */
  const char *xmin_help; /**< @brief Starting rotation in degrees help description.  */
  float xmax_arg;	/**< @brief Far rotation in degrees (default='90.0').  */
  char * xmax_orig;	/**< @brief Far rotation in degrees original value given at command line.  */
  const char *xmax_help; /**< @brief Far rotation in degrees help description.  */
  float zmin_arg;	/**< @brief Starting rotation in degrees (default='50.0').  */
  char * zmin_orig;	/**< @brief Starting rotation in degrees original value given at command line.  */
  const char *zmin_help; /**< @brief Starting rotation in degrees help description.  */
  float zmax_arg;	/**< @brief Far rotation in degrees (default='70.0').  */
  char * zmax_orig;	/**< @brief Far rotation in degrees original value given at command line.  */
  const char *zmax_help; /**< @brief Far rotation in degrees help description.  */
  
  int help_given ;	/**< @brief Whether help was given.  */
  int version_given ;	/**< @brief Whether version was given.  */
  int verbosity_given ;	/**< @brief Whether verbosity was given.  */
  int out_given ;	/**< @brief Whether out was given.  */
  int basename_given ;	/**< @brief Whether basename was given.  */
  int preamble_given ;	/**< @brief Whether preamble was given.  */
  int FileInput_given ;	/**< @brief Whether FileInput was given.  */
  int StringInput_given ;	/**< @brief Whether StringInput was given.  */
  int format_given ;	/**< @brief Whether format was given.  */
  int StepSize_given ;	/**< @brief Whether StepSize was given.  */
  int xmin_given ;	/**< @brief Whether xmin was given.  */
  int xmax_given ;	/**< @brief Whether xmax was given.  */
  int zmin_given ;	/**< @brief Whether zmin was given.  */
  int zmax_given ;	/**< @brief Whether zmax was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 0) */
  int check_required; /**< @brief whether to check that all required options were provided (default 0) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to 0
 * @return the initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_init();

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* SPIN_GNUPLOT_CMD_H */
