/** @file vol2vol_cmd.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.21
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef VOL2VOL_CMD_H
#define VOL2VOL_CMD_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define CMDLINE_PARSER_PACKAGE "vol2vol"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "0.24"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int verbosity_arg;	/**< @brief Set the verbosity level (0=quiet 10=verbose 20=bombastic) (default='0').  */
  char * verbosity_orig;	/**< @brief Set the verbosity level (0=quiet 10=verbose 20=bombastic) original value given at command line.  */
  const char *verbosity_help; /**< @brief Set the verbosity level (0=quiet 10=verbose 20=bombastic) help description.  */
  char * out_arg;	/**< @brief Output file name.  */
  char * out_orig;	/**< @brief Output file name original value given at command line.  */
  const char *out_help; /**< @brief Output file name help description.  */
  int pack_arg;	/**< @brief How to scale/fit counts into voxels.\n 0=PACK_SCALE, 1=PACK_CLIP, 2=PACK_WRAP (default='1').  */
  char * pack_orig;	/**< @brief How to scale/fit counts into voxels.\n 0=PACK_SCALE, 1=PACK_CLIP, 2=PACK_WRAP original value given at command line.  */
  const char *pack_help; /**< @brief How to scale/fit counts into voxels.\n 0=PACK_SCALE, 1=PACK_CLIP, 2=PACK_WRAP help description.  */
  int bpv_arg;	/**< @brief Bits per voxel.  This is an unsigned data type.\nCan be 8, 16, or 32. (default='8').  */
  char * bpv_orig;	/**< @brief Bits per voxel.  This is an unsigned data type.\nCan be 8, 16, or 32. original value given at command line.  */
  const char *bpv_help; /**< @brief Bits per voxel.  This is an unsigned data type.\nCan be 8, 16, or 32. help description.  */
  float xscale_arg;	/**< @brief Scale the voxels. (default='1.0').  */
  char * xscale_orig;	/**< @brief Scale the voxels. original value given at command line.  */
  const char *xscale_help; /**< @brief Scale the voxels. help description.  */
  float yscale_arg;	/**< @brief Scale the voxels. (default='1.0').  */
  char * yscale_orig;	/**< @brief Scale the voxels. original value given at command line.  */
  const char *yscale_help; /**< @brief Scale the voxels. help description.  */
  float zscale_arg;	/**< @brief Scale the voxels. (default='1.0').  */
  char * zscale_orig;	/**< @brief Scale the voxels. original value given at command line.  */
  const char *zscale_help; /**< @brief Scale the voxels. help description.  */
  
  int help_given ;	/**< @brief Whether help was given.  */
  int version_given ;	/**< @brief Whether version was given.  */
  int verbosity_given ;	/**< @brief Whether verbosity was given.  */
  int out_given ;	/**< @brief Whether out was given.  */
  int pack_given ;	/**< @brief Whether pack was given.  */
  int bpv_given ;	/**< @brief Whether bpv was given.  */
  int xscale_given ;	/**< @brief Whether xscale was given.  */
  int yscale_given ;	/**< @brief Whether yscale was given.  */
  int zscale_given ;	/**< @brief Whether zscale was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 0) */
  int check_required; /**< @brief whether to check that all required options were provided (default 0) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to 0
 * @return the initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_init();

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* VOL2VOL_CMD_H */
